# -*- encoding: utf-8 -*-

# TODO
# Name:  # TODO
# Legi:  # TODO

import numpy as np
import numpy.linalg
import scipy.optimize
import matplotlib.pyplot as plt

k1, k2, k3 = 0.1, 1e2, 1e4

def f(y):
    """Rechte Seite der Differenzialgleichung."""

    return np.empty((3,)) # TODO Implementieren Sie die rechte Seite.

def df(y):
    """Jacobimatrix der Funktion `f`."""
    return np.empty((3, 3)) # TODO Implementieren Sie `df`.

def integrate(f, y0, T, n_steps):
    """Berechnet eine approximative Lösung der Differenzialgleichung.

    Input:
        f : Rechte Seite der DGL.
        y0 : Startwert der DGL.
        T : Simulationsdauer.
        n_steps : Anzahl Zeitschritte.
    """

    n_vars = y0.size
    t, dt = np.linspace(0, T, n_steps+1, retstep=True)
    y = np.empty((n_steps+1, n_vars))
    y[0,:] = y0

    # TODO Berechnen Sie die Werte y[i,:] für i > 0.

    return t, y

def step(f, y0, t, dt):
    n_vars = y0.size

    # TODO Berechnen Sie den Wert zur Zeit `t + dt`.
    y1 = y0 # FIXME

    return y1

def nicer_fsolve(f, x0):
    """Etwas handlichere Version von `fsolve`.

    Dies ist im wesentlichen `fsolve(f, x0)`. Jedoch gilt
        nicer_fsolve(f, x0).shape == x0.shape

    Das heisst es behält die Form bei, dies ist nützlich für mehr-dimensionale
    arrays.

    Sie müssen diese Funktion nicht verwenden und dürfen auch `fsolve` direkt
    aufrufen. Falls Ihr Löser überhaupt `fsolve` benötigt.
    """

    shape = x0.shape
    root = scipy.optimize.fsolve(lambda y: f(y.reshape(shape)).reshape(-1), x0.reshape(-1))
    return root.reshape(shape)

def compute_solution(T, n_steps, should_plot_solution=True):
    """Berechnet die approximative Lösung zur Zeit T in `n_steps` Zeitschritten."""
    y0 = np.array([1.0, 0.0, 0.0])

    # TODO Eventuell müssen Sie die Integration in Phasen aufteilen.
    t, y = integrate(f, y0, T, n_steps)

    if should_plot_solution:
        plot_solution(t, y)

    return t, y

def plot_solution(t, y):
    plt.plot(t, y[:,0], label="A")
    plt.plot(t, y[:,1], label="B")
    plt.plot(t, y[:,2], label="C")

def compute_eigenvalues(y):
    """Berechnet die Eigenwerte von `df(y)`."""

    # TODO Berechnen Sie die Eigenwerte `df(y)`.
    ev = None # FIXME

    return ev

def ex_ii():
    # TODO implementieren Sie `compute_eigenvalues`.

    y1 = np.array([1.0, 0.0, 0.0])
    print(compute_eigenvalues(y1))

    y2 = np.array([0.999, 0.01, 0.01])
    print(compute_eigenvalues(y2))

    y3 = np.array([0.1, 0.00001, 0.99])
    print(compute_eigenvalues(y3))

def ex_v():
    # TODO Lösen Sie Teilaufgabe v) hier.
    # Beachten Sie die Funktion `compute_solution` welche den korrekten
    # Startwert enthält und auch gleich die Lösung plottet.
    pass

if __name__ == "__main__":

    ex_ii()
    ex_v()

    plt.savefig("3_reaction_equation.png")
    plt.show()
